Bug 1748228

Summary: Review Request: ghc-xdg-userdirs - Basic implementation of XDG user directories specification
Product: [Fedora] Fedora Reporter: Jens Petersen <petersen>
Component: Package ReviewAssignee: Elliott Sales de Andrade <quantum.analyst>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: package-review, quantum.analyst
Target Milestone: ---Flags: quantum.analyst: fedora-review+
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: ghc-xdg-userdirs-0.1.0.2-1.fc32 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-09-14 16:34:14 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:

Description Jens Petersen 2019-09-03 08:02:36 UTC
Spec URL: https://petersen.fedorapeople.org/reviews//ghc-xdg-userdirs.spec
SRPM URL: https://petersen.fedorapeople.org/reviews//ghc-xdg-userdirs-0.1.0.2-1.fc31.src.rpm

Description:
On Unix platforms, this should be a very straightforward implementation of the
XDG User Directory spec. On Windows, it will attempt to do the right thing with
regards to choosing appropriate directories.

Comment 2 Elliott Sales de Andrade 2019-09-05 04:36:09 UTC
There are many many warnings about symbols, and it's so long I can't post them
here, but this seems to be the same for all Haskell packages now.

Approved.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If your application is a C or C++ application you must list a
  BuildRequires against gcc, gcc-c++ or clang.
  Note: No gcc, gcc-c++ or clang found in BuildRequires
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/C_and_C++/


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD 3-clause "New" or "Revised" License", "Unknown or
     generated". 3 files have unknown license. Detailed output of
     licensecheck in 1748228-ghc-xdg-userdirs/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[?]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in ghc-xdg-
     userdirs
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ghc-xdg-userdirs-0.1.0.2-1.fc32.x86_64.rpm
          ghc-xdg-userdirs-devel-0.1.0.2-1.fc32.x86_64.rpm
          ghc-xdg-userdirs-0.1.0.2-1.fc32.src.rpm
ghc-xdg-userdirs.x86_64: E: library-not-linked-against-libc /usr/lib64/libHSxdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR-ghc8.6.5.so
ghc-xdg-userdirs.x86_64: W: no-documentation
ghc-xdg-userdirs-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 1 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
ghc-xdg-userdirs-devel.x86_64: W: no-documentation
ghc-xdg-userdirs.x86_64: W: undefined-non-weak-symbol /usr/lib64/libHSxdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR-ghc8.6.5.so *607
ghc-xdg-userdirs.x86_64: E: library-not-linked-against-libc /usr/lib64/libHSxdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR-ghc8.6.5.so
ghc-xdg-userdirs.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 1 errors, 607 warnings.



Unversioned so-files
--------------------
ghc-xdg-userdirs: /usr/lib64/libHSxdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR-ghc8.6.5.so

Source checksums
----------------
https://hackage.haskell.org/package/xdg-userdirs-0.1.0.2/xdg-userdirs-0.1.0.2.tar.gz :
  CHECKSUM(SHA256) this package     : 88aabbcb80dee5b669ad533af20000d561e6fe59ab1014ccc2482055d0a8046e
  CHECKSUM(SHA256) upstream package : 88aabbcb80dee5b669ad533af20000d561e6fe59ab1014ccc2482055d0a8046e


Requires
--------
ghc-xdg-userdirs (rpmlib, GLIBC filtered):
    libHSbase-4.12.0.0-ghc8.6.5.so()(64bit)
    libHScontainers-0.6.0.1-ghc8.6.5.so()(64bit)
    libHSdirectory-1.3.3.0-ghc8.6.5.so()(64bit)
    libHSfilepath-1.4.2.1-ghc8.6.5.so()(64bit)
    libHSghc-prim-0.5.3-ghc8.6.5.so()(64bit)
    libHSxdg-basedir-0.2.2-5JeadMzUyJb8NlvsA3m40x-ghc8.6.5.so()(64bit)
    rtld(GNU_HASH)

ghc-xdg-userdirs-devel (rpmlib, GLIBC filtered):
    ghc-compiler
    ghc-devel(base-4.12.0.0)
    ghc-devel(containers-0.6.0.1)
    ghc-devel(directory-1.3.3.0)
    ghc-devel(filepath-1.4.2.1)
    ghc-devel(xdg-basedir-0.2.2-5JeadMzUyJb8NlvsA3m40x)
    ghc-xdg-userdirs(x86-64)



Provides
--------
ghc-xdg-userdirs:
    ghc-xdg-userdirs
    ghc-xdg-userdirs(x86-64)
    libHSxdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR-ghc8.6.5.so()(64bit)

ghc-xdg-userdirs-devel:
    ghc-devel(xdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR)
    ghc-xdg-userdirs-devel
    ghc-xdg-userdirs-devel(x86-64)
    ghc-xdg-userdirs-static
    ghc-xdg-userdirs-static(x86-64)



Generated by fedora-review 0.7.2 (65d36bb) last change: 2019-04-09
Command line :/usr/bin/fedora-review -b 1748228 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Haskell, C/C++, Generic, Shell-api
Disabled plugins: R, fonts, Perl, SugarActivity, Python, Java, PHP, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Jens Petersen 2019-09-06 10:07:32 UTC
Thanks, Elliot!


(In reply to Elliott Sales de Andrade from comment #2)
> ghc-xdg-userdirs.x86_64: W: undefined-non-weak-symbol
> /usr/lib64/libHSxdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR-ghc8.6.5.so *607

I reported this upstream as an RFE now (see bug 1719810).

> ghc-xdg-userdirs.x86_64: E: library-not-linked-against-libc
> /usr/lib64/libHSxdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR-ghc8.6.5.so

I also discussed this with the upstream maintainer.

Is this listed in the Fedora Packaging Guidelines?  Or is rpmlint being pedantic?

Comment 4 Jens Petersen 2019-09-06 10:50:56 UTC
(In reply to Jens Petersen from comment #3)
> > ghc-xdg-userdirs.x86_64: E: library-not-linked-against-libc
> > /usr/lib64/libHSxdg-userdirs-0.1.0.2-AlWEG884APmJXb2i5mkSdR-ghc8.6.5.so
> 
> I also discussed this with the upstream maintainer.
> 
> Is this listed in the Fedora Packaging Guidelines?  Or is rpmlint being
> pedantic?

I asked rpmlint in bug 1749738.

Comment 6 Gwyn Ciesla 2019-09-06 13:04:02 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/ghc-xdg-userdirs

Comment 7 Fedora Update System 2019-09-09 04:55:57 UTC
FEDORA-2019-357899cb71 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-357899cb71

Comment 8 Fedora Update System 2019-09-09 05:33:39 UTC
ghc-xdg-userdirs-0.1.0.2-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-357899cb71

Comment 9 Fedora Update System 2019-09-14 16:34:14 UTC
ghc-xdg-userdirs-0.1.0.2-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2019-12-21 17:28:23 UTC
FEDORA-2019-b3e08f274a has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-b3e08f274a

Comment 11 Fedora Update System 2019-12-26 14:14:23 UTC
ghc-xdg-userdirs-0.1.0.2-2.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-b3e08f274a

Comment 12 Fedora Update System 2020-01-04 22:15:35 UTC
ghc-xdg-userdirs-0.1.0.2-2.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.